"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.JQLEditorAsync = void 0;
var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));
var _react = _interopRequireDefault(require("react"));
var _reactLooselyLazy = require("react-loosely-lazy");
var _errorBoundary = require("./ui/error-boundary");
var _intlProvider = require("./ui/intl-provider");
var _jqlEditorLayout = require("./ui/jql-editor-layout");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || (0, _typeof2.default)(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var JQLEditor = (0, _reactLooselyLazy.lazyForPaint)(function () {
  return Promise.resolve().then(function () {
    return _interopRequireWildcard(require( /* webpackChunkName: "async-jql-editor" */'./ui/jql-editor'));
  }).then(function (_ref) {
    var JQLEditorUI = _ref.default;
    return JQLEditorUI;
  });
}, {
  ssr: false
});
var JQLEditorAsync = (0, _intlProvider.withIntlProvider)((0, _errorBoundary.withErrorBoundary)(function (props) {
  return /*#__PURE__*/_react.default.createElement(_reactLooselyLazy.LazySuspense, {
    fallback: /*#__PURE__*/_react.default.createElement(_jqlEditorLayout.JQLEditorReadOnly, {
      query: props.query,
      isSearch: !!props.onSearch,
      isCompact: props.isCompact
    })
  }, /*#__PURE__*/_react.default.createElement(JQLEditor, props));
}));
exports.JQLEditorAsync = JQLEditorAsync;