"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TooltipContent = exports.OptionName = exports.OptionListItem = exports.OptionHighlight = exports.FieldTypeIcon = exports.FieldType = exports.DeprecatedOptionContainer = void 0;
var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));
var _react = require("@emotion/react");
var _styled = _interopRequireDefault(require("@emotion/styled"));
var _colors = require("@atlaskit/theme/colors");
var _constants = require("@atlaskit/theme/constants");
var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7, _templateObject8, _templateObject9;
var TooltipContent = _styled.default.div(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n  font-family: ", ";\n"])), _constants.fontFamily);

// eslint-disable-next-line @atlaskit/design-system/ensure-design-token-usage
exports.TooltipContent = TooltipContent;
var OptionListItem = _styled.default.li(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["\n  cursor: pointer;\n  padding: ", " ", "px;\n  font-family: ", ";\n  line-height: 24px;\n  ", "\n  ", "\n"])), "var(--ds-space-075, 6px)", 5 / 4 * (0, _constants.gridSize)(), _constants.codeFontFamily, function (props) {
  return props.isSelected ? (0, _react.css)(_templateObject3 || (_templateObject3 = (0, _taggedTemplateLiteral2.default)(["\n          background: ", ";\n        "])), "var(--ds-background-neutral-subtle-hovered, ".concat(_colors.N20, ")")) : '';
}, function (props) {
  return props.isDeprecated ? (0, _react.css)(_templateObject4 || (_templateObject4 = (0, _taggedTemplateLiteral2.default)(["\n          cursor: default;\n          color: ", ";\n        "])), "var(--ds-text-disabled, ".concat(_colors.N50, ")")) : '';
});
exports.OptionListItem = OptionListItem;
var OptionName = _styled.default.div(_templateObject5 || (_templateObject5 = (0, _taggedTemplateLiteral2.default)(["\n  color: ", ";\n  overflow: hidden;\n  white-space: nowrap;\n  text-overflow: ellipsis;\n  // Added so that overflowed option names do not squish the deprecated info icon\n  flex: 1;\n"])), "var(--ds-text, ".concat(_colors.N800, ")"));
exports.OptionName = OptionName;
var DeprecatedOptionContainer = _styled.default.div(_templateObject6 || (_templateObject6 = (0, _taggedTemplateLiteral2.default)(["\n  color: ", ";\n  display: flex;\n  justify-content: space-between;\n  opacity: 0.6;\n"])), "var(--ds-text-disabled, ".concat(_colors.N50, ")"));
exports.DeprecatedOptionContainer = DeprecatedOptionContainer;
var OptionHighlight = _styled.default.span(_templateObject7 || (_templateObject7 = (0, _taggedTemplateLiteral2.default)(["\n  font-weight: bold;\n"])));
exports.OptionHighlight = OptionHighlight;
var FieldType = _styled.default.div(_templateObject8 || (_templateObject8 = (0, _taggedTemplateLiteral2.default)(["\n  display: flex;\n  align-items: center;\n  margin-top: calc(-1 * ", ");\n  color: ", ";\n"])), "var(--ds-space-025, 2px)", "var(--ds-text-subtlest, ".concat(_colors.N100, ")"));
exports.FieldType = FieldType;
var FieldTypeIcon = _styled.default.span(_templateObject9 || (_templateObject9 = (0, _taggedTemplateLiteral2.default)(["\n  display: flex;\n  margin-right: ", ";\n"])), "var(--ds-space-050, 4px)");
exports.FieldTypeIcon = FieldTypeIcon;