"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _jqlEditorCommon = require("@atlassianlabs/jql-editor-common");
var _analytics = require("../../../../analytics");
var _state = require("../../../../state");
var _autocompleteDropdown = _interopRequireDefault(require("../autocomplete-dropdown"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var Autocomplete = function Autocomplete(_ref) {
  var keymap = _ref.keymap,
    onClick = _ref.onClick;
  var _useAutocompleteOptio = (0, _state.useAutocompleteOptions)(),
    _useAutocompleteOptio2 = (0, _slicedToArray2.default)(_useAutocompleteOptio, 1),
    options = _useAutocompleteOptio2[0];
  var _useAutocompleteLoadi = (0, _state.useAutocompleteLoading)(),
    _useAutocompleteLoadi2 = (0, _slicedToArray2.default)(_useAutocompleteLoadi, 1),
    loading = _useAutocompleteLoadi2[0];
  var _useStoreActions = (0, _state.useStoreActions)(),
    _useStoreActions2 = (0, _slicedToArray2.default)(_useStoreActions, 2),
    createAndFireAnalyticsEvent = _useStoreActions2[1].createAndFireAnalyticsEvent;
  var handleClick = (0, _react.useCallback)(function (option, analyticsAttributes) {
    onClick(option);
    createAndFireAnalyticsEvent({
      action: _analytics.Action.SELECTED,
      actionSubject: _analytics.ActionSubject.AUTOCOMPLETE_OPTION,
      eventType: _jqlEditorCommon.EventType.TRACK,
      attributes: _objectSpread({}, analyticsAttributes)
    });
  }, [createAndFireAnalyticsEvent, onClick]);
  return /*#__PURE__*/_react.default.createElement(_autocompleteDropdown.default, {
    options: options,
    loading: loading,
    keymap: keymap,
    onClick: handleClick
  });
};
var _default = Autocomplete;
exports.default = _default;