"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _prosemirrorKeymap = require("prosemirror-keymap");
var _prosemirrorState = require("prosemirror-state");
var _pluginKeymap = require("../common/plugin-keymap");
var _constants = require("./constants");
var _view = _interopRequireDefault(require("./view"));
var getKeyHandler = function getKeyHandler(keymap, key) {
  return function (state, dispatch, view) {
    var binding = keymap.getKeyBinding(key);
    return binding ? binding(state, dispatch, view) : false;
  };
};
var autocompletePlugin = function autocompletePlugin(portalActions, enableRichInlineNodes) {
  var _keydownHandler;
  // Empty keymap passed down to the React component so it can register key bindings
  var keymap = new _pluginKeymap.PluginKeymap();
  return new _prosemirrorState.Plugin({
    key: _constants.JQLAutocompletePluginKey,
    view: function view(editorView) {
      var view = new _view.default(editorView, keymap, portalActions, enableRichInlineNodes);
      // Initialise view to mount the react component
      view.init();
      return view;
    },
    props: {
      handleKeyDown: (0, _prosemirrorKeymap.keydownHandler)((_keydownHandler = {}, (0, _defineProperty2.default)(_keydownHandler, _constants.ARROW_UP_KEY, getKeyHandler(keymap, _constants.ARROW_UP_KEY)), (0, _defineProperty2.default)(_keydownHandler, _constants.ARROW_DOWN_KEY, getKeyHandler(keymap, _constants.ARROW_DOWN_KEY)), (0, _defineProperty2.default)(_keydownHandler, _constants.CMD_ARROW_UP_KEY, getKeyHandler(keymap, _constants.CMD_ARROW_UP_KEY)), (0, _defineProperty2.default)(_keydownHandler, _constants.CMD_ARROW_DOWN_KEY, getKeyHandler(keymap, _constants.CMD_ARROW_DOWN_KEY)), (0, _defineProperty2.default)(_keydownHandler, _constants.HOME_KEY, getKeyHandler(keymap, _constants.HOME_KEY)), (0, _defineProperty2.default)(_keydownHandler, _constants.END_KEY, getKeyHandler(keymap, _constants.END_KEY)), (0, _defineProperty2.default)(_keydownHandler, _constants.ESCAPE_KEY, getKeyHandler(keymap, _constants.ESCAPE_KEY)), (0, _defineProperty2.default)(_keydownHandler, _constants.ENTER_KEY, getKeyHandler(keymap, _constants.ENTER_KEY)), (0, _defineProperty2.default)(_keydownHandler, _constants.TAB_KEY, getKeyHandler(keymap, _constants.TAB_KEY)), _keydownHandler))
    }
  });
};
var _default = autocompletePlugin;
exports.default = _default;