"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handleFieldPropertyIdRuleError = void 0;
var _jqlParser = require("@atlassianlabs/jql-parser");
var _messages = require("../messages");
/**
 * Show the appropriate error message when parsing JQL fails and a field property ID rule was expected.
 */
var handleFieldPropertyIdRuleError = function handleFieldPropertyIdRuleError(currentToken, intl) {
  var isEOF = currentToken.type === _jqlParser.JQLLexer.EOF;
  return isEOF ? intl.formatMessage(_messages.errorMessages.expectingFieldPropertyIdBeforeEOF) : intl.formatMessage(_messages.errorMessages.expectingFieldPropertyIdButReceived, {
    received: currentToken.text
  });
};
exports.handleFieldPropertyIdRuleError = handleFieldPropertyIdRuleError;