"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handleFieldRuleError = void 0;
var _jqlParser = require("@atlassianlabs/jql-parser");
var _messages = require("../messages");
/**
 * Show the appropriate error message when parsing JQL fails and a field rule was expected.
 */
var handleFieldRuleError = function handleFieldRuleError(currentToken, intl) {
  var isEOF = currentToken.type === _jqlParser.JQLLexer.EOF;
  if (currentToken.type === _jqlParser.JQLLexer.LBRACKET) {
    return intl.formatMessage(_messages.errorMessages.expectingCFButReceived);
  }
  return isEOF ? intl.formatMessage(_messages.errorMessages.expectingFieldBeforeEOF) : intl.formatMessage(_messages.errorMessages.expectingFieldButReceived, {
    received: currentToken.text
  });
};
exports.handleFieldRuleError = handleFieldRuleError;