"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handleFunctionArgumentRuleError = void 0;
var _jqlParser = require("@atlassianlabs/jql-parser");
var _messages = require("../messages");
/**
 * Show the appropriate error message when parsing JQL fails and a function argument rule was expected.
 */
var handleFunctionArgumentRuleError = function handleFunctionArgumentRuleError(currentToken, intl) {
  var isEOF = currentToken.type === _jqlParser.JQLLexer.EOF;
  return isEOF ? intl.formatMessage(_messages.errorMessages.expectingFunctionArgBeforeEOF) : intl.formatMessage(_messages.errorMessages.expectingFunctionArgButReceived, {
    received: currentToken.text
  });
};
exports.handleFunctionArgumentRuleError = handleFunctionArgumentRuleError;