"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.handleOperatorRuleError = void 0;
var _jqlParser = require("@atlassianlabs/jql-parser");
var _messages = require("../messages");
// TODO: Figure out if we can show a message without hardcoded operators
/**
 * Show the appropriate error message when parsing JQL fails and an operator rule was expected.
 */
var handleOperatorRuleError = function handleOperatorRuleError(currentToken, intl) {
  var isEOF = currentToken.type === _jqlParser.JQLLexer.EOF;
  return isEOF ? intl.formatMessage(_messages.errorMessages.expectingOperatorBeforeEOF) : intl.formatMessage(_messages.errorMessages.expectingOperatorButReceived, {
    received: currentToken.text
  });
};
exports.handleOperatorRuleError = handleOperatorRuleError;