"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UserContainer = exports.NameContainer = exports.AvatarWrapper = void 0;
var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));
var _react = require("@emotion/react");
var _styled = _interopRequireDefault(require("@emotion/styled"));
var _colors = require("@atlaskit/theme/colors");
var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7;
// eslint-disable-next-line @atlaskit/design-system/ensure-design-token-usage
var UserContainer = _styled.default.span(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n  display: inline-flex;\n  align-items: center;\n  height: ", ";\n  padding: 1px;\n  border-radius: 10px;\n  cursor: pointer;\n  user-select: none;\n\n  ", "\n"])), "var(--ds-space-200, 16px)", function (_ref) {
  var selected = _ref.selected,
    error = _ref.error;
  if (selected) {
    if (error) {
      return (0, _react.css)(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["\n          color: ", ";\n          background-color: ", ";\n          text-decoration: wavy underline;\n          text-decoration-thickness: 1px;\n          text-decoration-skip-ink: none;\n          text-decoration-color: ", ";\n        "])), "var(--ds-text-inverse, ".concat(_colors.N0, ")"), "var(--ds-background-danger-bold, ".concat(_colors.R400, ")"), "var(--ds-text-inverse, ".concat(_colors.N0, ")"));
    } else {
      return (0, _react.css)(_templateObject3 || (_templateObject3 = (0, _taggedTemplateLiteral2.default)(["\n          color: ", ";\n          background-color: ", ";\n          box-shadow: 0 0 0 1px ", ";\n        "])), "var(--ds-text, ".concat(_colors.N0, ")"), "var(--ds-background-selected, ".concat(_colors.N500, ")"), "var(--ds-border-selected, transparent)");
    }
  } else {
    if (error) {
      return (0, _react.css)(_templateObject4 || (_templateObject4 = (0, _taggedTemplateLiteral2.default)(["\n          color: ", ";\n          background-color: ", ";\n          text-decoration: wavy underline;\n          text-decoration-thickness: 1px;\n          text-decoration-skip-ink: none;\n          text-decoration-color: ", ";\n\n          &:hover {\n            background-color: ", ";\n          }\n        "])), "var(--ds-text-subtle, ".concat(_colors.N500, ")"), "var(--ds-background-neutral, ".concat(_colors.N40, ")"), "var(--ds-text-danger, ".concat(_colors.R400, ")"), "var(--ds-background-neutral-hovered, ".concat(_colors.N50, ")"));
    } else {
      return (0, _react.css)(_templateObject5 || (_templateObject5 = (0, _taggedTemplateLiteral2.default)(["\n          color: ", ";\n          background-color: ", ";\n\n          &:hover {\n            background-color: ", ";\n          }\n        "])), "var(--ds-text-subtle, ".concat(_colors.N500, ")"), "var(--ds-background-neutral, ".concat(_colors.N40, ")"), "var(--ds-background-neutral-hovered, ".concat(_colors.N50, ")"));
    }
  }
});
exports.UserContainer = UserContainer;
var NameContainer = _styled.default.span(_templateObject6 || (_templateObject6 = (0, _taggedTemplateLiteral2.default)(["\n  margin-left: ", ";\n  margin-right: ", ";\n"])), "var(--ds-space-075, 6px)", "var(--ds-space-100, 8px)");

/* Override Avatar styles to match design spec */
// eslint-disable-next-line @atlaskit/design-system/ensure-design-token-usage
exports.NameContainer = NameContainer;
var AvatarWrapper = _styled.default.span(_templateObject7 || (_templateObject7 = (0, _taggedTemplateLiteral2.default)(["\n  > div {\n    top: 3px;\n\n    > span {\n      margin: 0;\n    }\n  }\n"])));
exports.AvatarWrapper = AvatarWrapper;