"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hydrateQuery = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _jqlAst = require("../../plugins/jql-ast");
var _replaceNodesTransaction = require("../../plugins/rich-inline-nodes/util/replace-nodes-transaction");
var _index = require("../index");
var _util = require("./util");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
var hydrateQuery = function hydrateQuery() {
  return /*#__PURE__*/function () {
    var _ref3 = (0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee(_ref, _ref2) {
      var setState, getState, dispatch, onHydrate, _getState, query, oldHydratedValues, enableRichInlineNodes, editorState, queryToHydrate, jast, visitor, newHydratedValues, hydratedValuesMap;
      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            setState = _ref.setState, getState = _ref.getState, dispatch = _ref.dispatch;
            onHydrate = _ref2.onHydrate;
            _getState = getState(), query = _getState.query, oldHydratedValues = _getState.hydratedValues, enableRichInlineNodes = _getState.enableRichInlineNodes, editorState = _getState.editorState;
            if (!(!enableRichInlineNodes || !onHydrate || !query)) {
              _context.next = 5;
              break;
            }
            return _context.abrupt("return");
          case 5:
            queryToHydrate = query;
            jast = (0, _jqlAst.getJastFromState)(editorState); // Hydration API will fail for syntactically invalid queries, including partial queries. We do want to hydrate those
            // as well to be able to handle queries like `assignee in (abc-123-def`, so we build an equivalent valid query.
            if (jast.query && jast.errors.length) {
              visitor = new _util.ValidQueryVisitor();
              queryToHydrate = jast.query.accept(visitor);
            }
            if (queryToHydrate) {
              _context.next = 10;
              break;
            }
            return _context.abrupt("return");
          case 10:
            _context.prev = 10;
            _context.next = 13;
            return onHydrate(queryToHydrate);
          case 13:
            newHydratedValues = _context.sent;
            hydratedValuesMap = Object.entries(newHydratedValues).reduce(function (map, _ref4) {
              var _ref5 = (0, _slicedToArray2.default)(_ref4, 2),
                fieldName = _ref5[0],
                values = _ref5[1];
              var valueMap = new Map(oldHydratedValues[fieldName]);
              values.forEach(function (value) {
                valueMap.set(value.id, value);
              });
              return _objectSpread(_objectSpread({}, map), {}, (0, _defineProperty2.default)({}, fieldName, valueMap));
            }, {});
            setState({
              hydratedValues: hydratedValuesMap
            });
            dispatch(replaceHydratedValuesWithRichInlineNodes());
            _context.next = 21;
            break;
          case 19:
            _context.prev = 19;
            _context.t0 = _context["catch"](10);
          case 21:
          case "end":
            return _context.stop();
        }
      }, _callee, null, [[10, 19]]);
    }));
    return function (_x, _x2) {
      return _ref3.apply(this, arguments);
    };
  }();
};
exports.hydrateQuery = hydrateQuery;
var replaceHydratedValuesWithRichInlineNodes = function replaceHydratedValuesWithRichInlineNodes() {
  return function (_ref6) {
    var getState = _ref6.getState,
      dispatch = _ref6.dispatch;
    var _getState2 = getState(),
      editorState = _getState2.editorState,
      hydratedValues = _getState2.hydratedValues;
    var transaction = (0, _replaceNodesTransaction.replaceRichInlineNodes)(editorState, hydratedValues);
    dispatch(_index.actions.onApplyEditorTransaction(transaction));
  };
};