"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BaseSearch = void 0;
var _react = _interopRequireWildcard(require("react"));
var _button = require("@atlaskit/button");
var _search = _interopRequireDefault(require("@atlaskit/icon/glyph/editor/search"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var style = {
  // Fixes an issue where loading button makes the editor flicker with a scrollbar
  overflow: 'hidden'
};
var BaseSearch = function BaseSearch(_ref) {
  var isDisabled = _ref.isDisabled,
    isSearching = _ref.isSearching,
    label = _ref.label,
    onSearch = _ref.onSearch;
  // Prevent click events being repeatedly fired if the Enter key is held down.
  var preventRepeatClick = (0, _react.useCallback)(function (e) {
    if (e.key === 'Enter' && e.repeat) {
      e.preventDefault();
    }
  }, []);
  return /*#__PURE__*/_react.default.createElement(_button.LoadingButton, {
    "aria-label": label,
    isDisabled: isDisabled,
    testId: "jql-editor-search",
    style: style,
    appearance: 'primary',
    spacing: 'none',
    onClick: onSearch,
    onKeyDown: preventRepeatClick,
    isLoading: isSearching,
    iconBefore: /*#__PURE__*/_react.default.createElement(_search.default, {
      label: '',
      size: 'medium'
    })
  });
};
exports.BaseSearch = BaseSearch;