"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BaseSyntaxHelp = void 0;
var _react = _interopRequireDefault(require("react"));
var _button = _interopRequireDefault(require("@atlaskit/button"));
var _question = _interopRequireDefault(require("@atlaskit/icon/glyph/question"));
var _colors = require("@atlaskit/theme/colors");
var _styled = require("./styled");
var BaseSyntaxHelp = function BaseSyntaxHelp(_ref) {
  var describedby = _ref.describedby,
    isDisabled = _ref.isDisabled,
    label = _ref.label,
    onClick = _ref.onClick;
  return /*#__PURE__*/_react.default.createElement(_styled.SyntaxHelpContainer, null, /*#__PURE__*/_react.default.createElement(_button.default, {
    "aria-describedby": describedby,
    "aria-label": label,
    isDisabled: isDisabled,
    appearance: 'subtle',
    spacing: 'none',
    target: 'blank',
    href: "https://confluence.atlassian.com/display/SERVICEDESKCLOUD/Advanced+searching",
    iconBefore: /*#__PURE__*/_react.default.createElement(_question.default, {
      label: '',
      primaryColor: isDisabled ? "var(--ds-icon-disabled, ".concat(_colors.N0, ")") : "var(--ds-icon-inverse, ".concat(_colors.N0, ")"),
      size: 'small'
    }),
    onClick: onClick
  }));
};
exports.BaseSyntaxHelp = BaseSyntaxHelp;