"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ExpandToggle = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _tooltip = _interopRequireDefault(require("@atlaskit/tooltip"));
var _analytics = require("../../../analytics");
var _constants = require("../../../common/constants");
var _styled = require("../../../common/styled");
var _useEditorTheme = require("../../../hooks/use-editor-theme");
var _state = require("../../../state");
var _tooltipTag = require("../../tooltip-tag");
var _baseExpandToggle = require("../base-expand-toggle");
var _messages = require("./messages");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
// eslint-disable-next-line @atlassian/tangerine/import/no-parent-imports

// eslint-disable-next-line @atlassian/tangerine/import/no-parent-imports

var ExpandToggle = function ExpandToggle() {
  var _useEditorThemeContex = (0, _useEditorTheme.useEditorThemeContext)(),
    expanded = _useEditorThemeContex.expanded,
    toggleExpanded = _useEditorThemeContex.toggleExpanded;
  var _useStoreActions = (0, _state.useStoreActions)(),
    _useStoreActions2 = (0, _slicedToArray2.default)(_useStoreActions, 2),
    createAndFireAnalyticsEvent = _useStoreActions2[1].createAndFireAnalyticsEvent;
  var _useScopedId = (0, _state.useScopedId)(_constants.JQL_EDITOR_INPUT_ID),
    _useScopedId2 = (0, _slicedToArray2.default)(_useScopedId, 1),
    editorId = _useScopedId2[0];
  var _useIntl = (0, _state.useIntl)(),
    _useIntl2 = (0, _slicedToArray2.default)(_useIntl, 1),
    intl = _useIntl2[0];
  var message;
  if (expanded) {
    message = intl.formatMessage(_messages.messages.collapseTooltip);
  } else {
    message = intl.formatMessage(_messages.messages.expandTooltip);
  }
  var onClick = (0, _react.useCallback)(function () {
    createAndFireAnalyticsEvent({
      action: _analytics.Action.CLICKED,
      actionSubject: _analytics.ActionSubject.BUTTON,
      actionSubjectId: _analytics.ActionSubjectId.EDITOR_EXPAND,
      eventType: _analytics.EventType.UI,
      attributes: {
        expanded: !expanded
      }
    });
    toggleExpanded();
  }, [expanded, createAndFireAnalyticsEvent, toggleExpanded]);
  return /*#__PURE__*/_react.default.createElement(_tooltip.default, {
    position: 'bottom',
    content: /*#__PURE__*/_react.default.createElement(_styled.TooltipContent, null, message),
    tag: _tooltipTag.TooltipTag
  }, /*#__PURE__*/_react.default.createElement(_baseExpandToggle.BaseExpandToggle, {
    expanded: expanded,
    editorId: editorId,
    label: intl.formatMessage(_messages.messages.buttonLabel),
    onClick: onClick
  }));
};
exports.ExpandToggle = ExpandToggle;