"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SyntaxHelp = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _tooltip = _interopRequireDefault(require("@atlaskit/tooltip"));
var _accessibility = require("../../../accessibility");
var _analytics = require("../../../analytics");
var _constants = require("../../../common/constants");
var _styled = require("../../../common/styled");
var _state = require("../../../state");
var _tooltipTag = require("../../tooltip-tag");
var _baseSyntaxHelp = require("../base-syntax-help");
var _messages = require("./messages");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
// eslint-disable-next-line @atlassian/tangerine/import/no-parent-imports

// eslint-disable-next-line @atlassian/tangerine/import/no-parent-imports

var SyntaxHelp = function SyntaxHelp() {
  var _useIntl = (0, _state.useIntl)(),
    _useIntl2 = (0, _slicedToArray2.default)(_useIntl, 1),
    intl = _useIntl2[0];
  var label = intl.formatMessage(_messages.messages.syntaxHelpTooltip);
  var _useScopedId = (0, _state.useScopedId)(_constants.SYNTAX_HELP_DESCRIPTION_ID),
    _useScopedId2 = (0, _slicedToArray2.default)(_useScopedId, 1),
    descriptionId = _useScopedId2[0];
  var _useOnSyntaxHelp = (0, _state.useOnSyntaxHelp)(),
    _useOnSyntaxHelp2 = (0, _slicedToArray2.default)(_useOnSyntaxHelp, 2),
    onSyntaxHelp = _useOnSyntaxHelp2[0],
    createAndFireAnalyticsEvent = _useOnSyntaxHelp2[1].createAndFireAnalyticsEvent;
  var onClick = (0, _react.useCallback)(function (e) {
    createAndFireAnalyticsEvent({
      action: _analytics.Action.CLICKED,
      actionSubject: _analytics.ActionSubject.BUTTON,
      actionSubjectId: _analytics.ActionSubjectId.EDITOR_HELP,
      eventType: _analytics.EventType.UI
    });
    var handled = onSyntaxHelp && onSyntaxHelp(e);
    // Prevent default behaviour when the event is handled on the consumer side.
    if (handled) {
      e.preventDefault();
    }
  }, [createAndFireAnalyticsEvent, onSyntaxHelp]);
  return /*#__PURE__*/_react.default.createElement(_tooltip.default, {
    position: 'bottom',
    content: /*#__PURE__*/_react.default.createElement(_styled.TooltipContent, null, label),
    tag: _tooltipTag.TooltipTag
  }, /*#__PURE__*/_react.default.createElement(_baseSyntaxHelp.BaseSyntaxHelp, {
    describedby: descriptionId,
    label: label,
    onClick: onClick
  }), /*#__PURE__*/_react.default.createElement(_accessibility.ScreenReaderText, {
    id: descriptionId
  }, intl.formatMessage(_messages.messages.syntaxHelpDescription)));
};
exports.SyntaxHelp = SyntaxHelp;