"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.JQLEditorFooterContent = void 0;
var _react = _interopRequireDefault(require("react"));
var _reactMagneticDi = require("react-magnetic-di");
var _useEditorViewHasInfos = require("../../hooks/use-editor-view-has-infos");
var _useEditorViewHasWarnings = require("../../hooks/use-editor-view-has-warnings");
var _useEditorViewIsInvalid = require("../../hooks/use-editor-view-is-invalid");
var _jqlEditorHelp = require("./jql-editor-help");
var _jqlMessages = require("./jql-messages");
/**
 * Message components are rendered by priority.
 * Message component decides on its own what exactly to render (GQL vs external messages).
 */

var JQLEditorFooterContent = function JQLEditorFooterContent() {
  var editorViewIsInvalid = (0, _useEditorViewIsInvalid.useEditorViewIsInvalid)();
  var editorViewHasWarnings = (0, _useEditorViewHasWarnings.useEditorViewHasWarnings)();
  var editorViewHasInfos = (0, _useEditorViewHasInfos.useEditorViewHasInfos)();
  if (editorViewIsInvalid) {
    return /*#__PURE__*/_react.default.createElement(_jqlMessages.ErrorMessages, null);
  }
  if (editorViewHasWarnings) {
    return /*#__PURE__*/_react.default.createElement(_jqlMessages.WarningMessages, null);
  }
  if (editorViewHasInfos) {
    return /*#__PURE__*/_react.default.createElement(_jqlMessages.InfoMessages, null);
  }
  return /*#__PURE__*/_react.default.createElement(_jqlEditorHelp.JQLEditorHelp, null);
};
exports.JQLEditorFooterContent = JQLEditorFooterContent;