"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ErrorMessages = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireWildcard(require("react"));
var _jqlAst = require("@atlassianlabs/jql-ast");
var _reactMagneticDi = require("react-magnetic-di");
var _form = require("@atlaskit/form");
var _constants = require("../../../../common/constants");
var _messages = require("../../../../common/messages");
var _useEditorViewIsInvalid = require("../../../../hooks/use-editor-view-is-invalid");
var _state = require("../../../../state");
var _format = require("../format");
var _messages2 = require("./messages");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var useFormattedErrorMessage = function useFormattedErrorMessage() {
  var _useIntl = (0, _state.useIntl)(),
    _useIntl2 = (0, _slicedToArray2.default)(_useIntl, 1),
    formatMessage = _useIntl2[0].formatMessage;
  var _useJqlError = (0, _state.useJqlError)(),
    _useJqlError2 = (0, _slicedToArray2.default)(_useJqlError, 1),
    jqlError = _useJqlError2[0];
  var _useExternalMessages = (0, _state.useExternalMessages)(),
    _useExternalMessages2 = (0, _slicedToArray2.default)(_useExternalMessages, 1),
    externalErrors = _useExternalMessages2[0].errors;
  var _useStoreActions = (0, _state.useStoreActions)(),
    _useStoreActions2 = (0, _slicedToArray2.default)(_useStoreActions, 2),
    externalErrorMessageViewed = _useStoreActions2[1].externalErrorMessageViewed;
  var editorViewIsInvalid = (0, _useEditorViewIsInvalid.useEditorViewIsInvalid)();
  (0, _react.useEffect)(function () {
    // Emit a UI event whenever external errors has changed
    externalErrorMessageViewed();
  }, [externalErrorMessageViewed, externalErrors]);
  if (!editorViewIsInvalid) {
    return null;
  }

  // Prioritise client over external errors
  if (jqlError instanceof _jqlAst.JQLSyntaxError) {
    return "".concat(jqlError.message, " ").concat(formatMessage(_messages2.messages.jqlErrorPosition, {
      lineNumber: jqlError.line,
      charPosition: jqlError.charPositionInLine + 1
    }));
  } else if (externalErrors.length > 0) {
    return /*#__PURE__*/_react.default.createElement(_format.FormatMessages, {
      messages: externalErrors
    });
  } else if (jqlError !== null) {
    return formatMessage(_messages.commonMessages.unknownError);
  }
  return null;
};
var ErrorMessages = function ErrorMessages() {
  var _useScopedId = (0, _state.useScopedId)(_constants.JQL_EDITOR_INPUT_ID),
    _useScopedId2 = (0, _slicedToArray2.default)(_useScopedId, 1),
    editorId = _useScopedId2[0];
  var errorMessage = useFormattedErrorMessage();
  return errorMessage != null ? /*#__PURE__*/_react.default.createElement(_format.MessageContainer, null, /*#__PURE__*/_react.default.createElement(_form.ErrorMessage, {
    testId: "jql-editor-validation"
  }, /*#__PURE__*/_react.default.createElement("span", {
    role: "alert",
    "aria-describedby": editorId
  }, errorMessage))) : null;
};
exports.ErrorMessages = ErrorMessages;