"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MessageContainer = exports.FormatMessages = void 0;
var _react = _interopRequireDefault(require("react"));
var _useEditorTheme = require("../../../../hooks/use-editor-theme");
var _styled = require("./styled");
// Max number messages we want to show
var MAX_MESSAGES = 10;
var MessageContainer = function MessageContainer(_ref) {
  var children = _ref.children;
  var _useEditorThemeContex = (0, _useEditorTheme.useEditorThemeContext)(),
    isSearch = _useEditorThemeContex.isSearch;
  return /*#__PURE__*/_react.default.createElement(_styled.MessageContainer, {
    isSearch: isSearch
  }, children);
};
exports.MessageContainer = MessageContainer;
var FormatMessages = function FormatMessages(_ref2) {
  var messages = _ref2.messages;
  if (messages.length === 0) {
    return null;
  }
  if (messages.length === 1) {
    return /*#__PURE__*/_react.default.createElement("span", null, messages[0].message);
  }
  return /*#__PURE__*/_react.default.createElement(_styled.MessageList, null, messages.slice(0, MAX_MESSAGES).map(function (m, i) {
    return /*#__PURE__*/_react.default.createElement("li", {
      key: i
    }, m.message);
  }));
};
exports.FormatMessages = FormatMessages;