"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useFormattedInfoMessage = exports.InfoMessages = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = _interopRequireDefault(require("react"));
var _reactMagneticDi = require("react-magnetic-di");
var _form = require("@atlaskit/form");
var _info = _interopRequireDefault(require("@atlaskit/icon/glyph/info"));
var colors = _interopRequireWildcard(require("@atlaskit/theme/colors"));
var _useEditorViewHasInfos = require("../../../../hooks/use-editor-view-has-infos");
var _state = require("../../../../state");
var _format = require("../format");
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var useFormattedInfoMessage = function useFormattedInfoMessage() {
  var _useExternalMessages = (0, _state.useExternalMessages)(),
    _useExternalMessages2 = (0, _slicedToArray2.default)(_useExternalMessages, 1),
    externalInfos = _useExternalMessages2[0].infos;
  var hasInfos = (0, _useEditorViewHasInfos.useEditorViewHasInfos)();
  if (!hasInfos) {
    return null;
  }
  return /*#__PURE__*/_react.default.createElement(_format.FormatMessages, {
    messages: externalInfos
  });
};
exports.useFormattedInfoMessage = useFormattedInfoMessage;
var InfoMessages = function InfoMessages() {
  var infoMessage = useFormattedInfoMessage();
  return infoMessage != null ? /*#__PURE__*/_react.default.createElement(_format.MessageContainer, null, /*#__PURE__*/_react.default.createElement(_form.HelperMessage, {
    testId: "jql-editor-info-message"
  }, /*#__PURE__*/_react.default.createElement(_info.default, {
    label: "",
    primaryColor: "var(--ds-icon-information, ".concat(colors.B500, ")"),
    size: "small"
  }), infoMessage)) : null;
};
exports.InfoMessages = InfoMessages;