"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ReadOnlyEditorViewContainer = exports.ReadOnlyEditorView = exports.LineNumberToolbar = exports.EditorViewContainer = exports.EditorView = exports.EditorMain = exports.EditorFooter = exports.EditorControls = void 0;
var _taggedTemplateLiteral2 = _interopRequireDefault(require("@babel/runtime/helpers/taggedTemplateLiteral"));
var _react = require("@emotion/react");
var _styled = _interopRequireDefault(require("@emotion/styled"));
var _colors = require("@atlaskit/theme/colors");
var _constants = require("@atlaskit/theme/constants");
var _constants2 = require("../../plugins/validation-tooltip/constants");
var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7, _templateObject8, _templateObject9, _templateObject10, _templateObject11, _templateObject12, _templateObject13, _templateObject14, _templateObject15;
var fadeIn = (0, _react.keyframes)(_templateObject || (_templateObject = (0, _taggedTemplateLiteral2.default)(["\n  from {\n    opacity: 0;\n  }\n\n  to {\n    opacity: 1;\n  }\n"])));
var fadeOut = (0, _react.keyframes)(_templateObject2 || (_templateObject2 = (0, _taggedTemplateLiteral2.default)(["\n  from {\n    visibility: visible;\n    opacity: 1;\n  }\n\n  to {\n    opacity: 0;\n  }\n"])));
var EditorMain = _styled.default.div(_templateObject3 || (_templateObject3 = (0, _taggedTemplateLiteral2.default)(["\n  /* CSS reset */\n  font-family: ", ";\n  font-size: ", "px;\n  flex-grow: 1;\n\n  /* These styles and animations are derived from @atlaskit/tooltip */\n\n  .", " {\n    background-color: ", ";\n    color: ", ";\n    border-radius: ", ";\n    box-sizing: border-box;\n    font-size: 12px;\n    line-height: 1.3;\n    max-width: 240px;\n    padding: ", " ", ";\n    word-wrap: break-word;\n    overflow-wrap: break-word;\n    z-index: ", ";\n    pointer-events: none;\n    position: absolute;\n    visibility: hidden;\n\n    /* Horizontally center and vertically position above the target element */\n    transform: translate(-50%, calc(-100% - ", "));\n\n    &.", " {\n      animation: ", " 350ms cubic-bezier(0.15, 1, 0.3, 1);\n      visibility: visible;\n    }\n\n    &.", " {\n      animation: ", " 350ms cubic-bezier(0.15, 1, 0.3, 1);\n    }\n  }\n"])), _constants.fontFamily, _constants.fontSize, _constants2.TOOLTIP_CLASSNAME, "var(--ds-background-neutral-bold, ".concat(_colors.N800, ")"), "var(--ds-text-inverse, ".concat(_colors.N0, ")"), "var(--ds-border-radius-100, 3px)", "var(--ds-space-025, 2px)", "var(--ds-space-075, 6px)", _constants.layers.tooltip(), "var(--ds-space-200, 16px)", _constants2.TOOLTIP_ENTER_CLASSNAME, fadeIn, _constants2.TOOLTIP_EXIT_CLASSNAME, fadeOut);
exports.EditorMain = EditorMain;
var EditorFooter = _styled.default.div(_templateObject4 || (_templateObject4 = (0, _taggedTemplateLiteral2.default)(["\n  display: flex;\n  justify-content: space-between;\n  /* We always have at least 1 row of space allocated to the footer */\n  min-height: 20px;\n"])));

// Height (in px) for a single row in the editor
exports.EditorFooter = EditorFooter;
var rowHeight = (0, _constants.gridSize)() * 2.75;
// Vertical padding for the editor input
var getEditorInputVerticalPadding = function getEditorInputVerticalPadding(isCompact) {
  return isCompact ? 3 : 7;
};
var editorInputHorizontalPadding = 6;
var EditorViewContainer = _styled.default.div(_templateObject5 || (_templateObject5 = (0, _taggedTemplateLiteral2.default)(["\n  background-color: ", ";\n  border-style: solid;\n  border-width: 2px;\n  border-color: ", ";\n  border-radius: ", ";\n  box-sizing: border-box;\n  color: ", ";\n  display: flex;\n  overflow: auto;\n  transition: background-color 0.2s ease-in-out, border-color 0.2s ease-in-out;\n\n  ", "\n\n  ", "\n"])), "var(--ds-background-input, ".concat(_colors.N10, ")"), "var(--ds-border, ".concat(_colors.N40, ")"), "var(--ds-border-radius-100, 3px)", "var(--ds-text, ".concat(_colors.N900, ")"), function (props) {
  return props.editorViewHasFocus ? (0, _react.css)(_templateObject6 || (_templateObject6 = (0, _taggedTemplateLiteral2.default)(["\n          background-color: ", ";\n          border-color: ", ";\n        "])), "var(--ds-surface, ".concat(_colors.N0, ")"), "var(--ds-border-focused, ".concat(_colors.B100, ")")) : (0, _react.css)(_templateObject7 || (_templateObject7 = (0, _taggedTemplateLiteral2.default)(["\n          :hover {\n            background-color: ", ";\n          }\n        "])), "var(--ds-background-input-hovered, ".concat(_colors.N30, ")"));
}, function (props) {
  return props.editorViewIsInvalid && (0, _react.css)(_templateObject8 || (_templateObject8 = (0, _taggedTemplateLiteral2.default)(["\n      border-color: ", ";\n    "])), "var(--ds-border-danger, ".concat(_colors.R400, ")"));
});
exports.EditorViewContainer = EditorViewContainer;
var ReadOnlyEditorViewContainer = (0, _styled.default)(EditorViewContainer)(_templateObject9 || (_templateObject9 = (0, _taggedTemplateLiteral2.default)(["\n  background-color: ", ";\n  color: ", ";\n  pointer-events: none;\n"])), "var(--ds-background-disabled, ".concat(_colors.N30, ")"), "var(--ds-text-disabled, ".concat(_colors.N100, ")"));
exports.ReadOnlyEditorViewContainer = ReadOnlyEditorViewContainer;
var LineNumberToolbar = _styled.default.div(_templateObject10 || (_templateObject10 = (0, _taggedTemplateLiteral2.default)(["\n  background-color: ", ";\n  flex-shrink: 0;\n  width: 30px;\n  position: sticky;\n  top: 0;\n\n  ", "\n"])), "var(--ds-background-neutral, ".concat(_colors.N30, ")"), function (props) {
  return !props.lineNumbersVisible && (0, _react.css)(_templateObject11 || (_templateObject11 = (0, _taggedTemplateLiteral2.default)(["\n      display: none;\n    "])));
});

/**
 * The main div which the Prosemirror editor will be rendered into.
 */
exports.LineNumberToolbar = LineNumberToolbar;
var EditorView = _styled.default.div(_templateObject12 || (_templateObject12 = (0, _taggedTemplateLiteral2.default)(["\n  counter-reset: lineNumber;\n  flex-grow: 1;\n\n  transition: height 250ms cubic-bezier(0.15, 1, 0.3, 1),\n    max-height 250ms cubic-bezier(0.15, 1, 0.3, 1);\n  max-height: ", "px;\n\n  line-height: ", ";\n  font-family: ", ";\n  word-break: break-word;\n  overflow-wrap: anywhere;\n  white-space: pre-wrap;\n\n  &[data-expanded] {\n    height: ", "px;\n    max-height: ", "px;\n  }\n\n  .ProseMirror {\n    color: ", ";\n    padding: ", "px\n      ", "px;\n\n    &:focus {\n      outline: none;\n    }\n\n    .mark-token-keyword {\n      color: ", ";\n    }\n\n    .mark-token-field {\n      color: ", ";\n    }\n\n    .mark-token-operator {\n      color: ", ";\n    }\n\n    .mark-token-error {\n      color: ", ";\n      text-decoration: wavy underline;\n      text-decoration-thickness: 1px;\n      text-decoration-skip-ink: none;\n    }\n  }\n\n  p {\n    margin: 0;\n    counter-increment: lineNumber;\n    position: relative;\n\n    /* Show the current line number before each paragraph block. */\n\n    &::before {\n      content: counter(lineNumber);\n      color: ", ";\n      font-size: 10px;\n      line-height: ", ";\n      padding: 0 ", " 0 ", ";\n      position: absolute;\n      box-sizing: border-box;\n      /* Shift the line number tag 100% (plus 8px padding) to the left to position it inside the LineNumberToolbar */\n      transform: translateX(calc(-100% - ", "));\n\n      /* We can fit 3 digits before ellipses. This is not very responsive but saves us having to add expensive width\n        recalculation logic to the LineNumberToolbar for a scenario that *should* never happen. */\n      max-width: 30px;\n      text-overflow: ellipsis;\n      overflow: hidden;\n      white-space: nowrap;\n\n      ", "\n    }\n  }\n"])), function (props) {
  return rowHeight * props.defaultMaxRows + getEditorInputVerticalPadding(props.isCompact) * 2;
}, rowHeight / (0, _constants.fontSize)(), _constants.codeFontFamily, function (props) {
  return rowHeight * props.expandedRows + getEditorInputVerticalPadding(props.isCompact) * 2;
}, function (props) {
  return rowHeight * props.expandedRows + getEditorInputVerticalPadding(props.isCompact) * 2;
}, "var(--ds-text, ".concat(_colors.N700, ")"), function (props) {
  return getEditorInputVerticalPadding(props.isCompact);
}, editorInputHorizontalPadding, "var(--ds-text-accent-purple, ".concat(_colors.P400, ")"), "var(--ds-text-accent-blue, ".concat(_colors.B300, ")"), "var(--ds-text-accent-green, ".concat(_colors.G300, ")"), "var(--ds-text-danger, ".concat(_colors.R400, ")"), "var(--ds-text-subtlest, ".concat(_colors.N100, ")"), rowHeight / 10, "var(--ds-space-100, 8px)", "var(--ds-space-025, 2px)", "var(--ds-space-100, 8px)", function (props) {
  return !props.lineNumbersVisible && (0, _react.css)(_templateObject13 || (_templateObject13 = (0, _taggedTemplateLiteral2.default)(["\n          display: none;\n        "])));
});
exports.EditorView = EditorView;
var ReadOnlyEditorView = (0, _styled.default)(EditorView)(_templateObject14 || (_templateObject14 = (0, _taggedTemplateLiteral2.default)(["\n  /* We need to replicate padding from the inner prosemirror element in our read only state. That means we also need\n  recompute max height excluding the child padding. */\n  padding: ", "px\n    ", "px;\n  max-height: ", "px;\n\n  > p {\n    /* Prevent collapsing empty paragraphs */\n    min-height: ", "px;\n  }\n"])), function (props) {
  return getEditorInputVerticalPadding(props.isCompact);
}, editorInputHorizontalPadding, function (props) {
  return rowHeight * props.defaultMaxRows;
}, rowHeight);
exports.ReadOnlyEditorView = ReadOnlyEditorView;
var EditorControls = _styled.default.div(_templateObject15 || (_templateObject15 = (0, _taggedTemplateLiteral2.default)(["\n  align-items: center;\n  display: flex;\n  flex-shrink: 0;\n  margin-left: auto;\n  margin-right: ", "px;\n  line-height: normal;\n  position: sticky;\n  top: 0;\n  height: ", "px;\n"])), function (props) {
  return props.isSearch ? getEditorInputVerticalPadding(props.isCompact) - 1 // the search button needs the same vertical & horizontal spacing
  : editorInputHorizontalPadding - 3;
}, function (props) {
  return rowHeight + 2 * getEditorInputVerticalPadding(props.isCompact);
});
exports.EditorControls = EditorControls;