"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _reactIntlNext = require("react-intl-next");
var _reactMagneticDi = require("react-magnetic-di");
var _analytics = require("../../analytics");
var _useEditorTheme = require("../../hooks/use-editor-theme");
var _state = require("../../state");
var _jqlEditorPortalProvider = require("../jql-editor-portal-provider");
var _jqlEditorView = _interopRequireDefault(require("../jql-editor-view"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
// eslint-disable-next-line @atlassian/tangerine/import/no-parent-imports

// eslint-disable-next-line @atlassian/tangerine/import/no-parent-imports

var JQLEditorInner = function JQLEditorInner(_ref) {
  var analyticsSource = _ref.analyticsSource,
    query = _ref.query,
    _ref$messages = _ref.messages,
    messages = _ref$messages === void 0 ? [] : _ref$messages,
    inputRef = _ref.inputRef,
    isSearching = _ref.isSearching,
    onEditorMounted = _ref.onEditorMounted,
    onDebugUnsafeMessage = _ref.onDebugUnsafeMessage,
    onHydrate = _ref.onHydrate,
    onUpdate = _ref.onUpdate,
    onSearch = _ref.onSearch,
    autocompleteProvider = _ref.autocompleteProvider,
    intl = _ref.intl,
    _ref$enableRichInline = _ref.enableRichInlineNodes,
    enableRichInlineNodes = _ref$enableRichInline === void 0 ? false : _ref$enableRichInline,
    isCompact = _ref.isCompact,
    onSyntaxHelp = _ref.onSyntaxHelp;
  var editorTheme = (0, _useEditorTheme.useEditorTheme)({
    isSearch: !!onSearch,
    isCompact: isCompact
  });
  var _useJqlEditorAnalytic = (0, _analytics.useJqlEditorAnalytics)(analyticsSource),
    createAndFireAnalyticsEvent = _useJqlEditorAnalytic.createAndFireAnalyticsEvent;

  // Create and update a mutable ref for our intl object so it can be used by Prosemirror plugins.
  var intlRef = (0, _react.useRef)(intl);
  (0, _react.useEffect)(function () {
    intlRef.current = intl;
  }, [intl]);
  return /*#__PURE__*/_react.default.createElement(_state.EditorStateContainer, {
    query: query,
    externalMessages: messages,
    isSearching: isSearching,
    intlRef: intlRef,
    onEditorMounted: onEditorMounted,
    onDebugUnsafeMessage: onDebugUnsafeMessage,
    onHydrate: onHydrate,
    onUpdate: onUpdate,
    onSearch: onSearch,
    createAndFireAnalyticsEvent: createAndFireAnalyticsEvent,
    autocompleteProvider: autocompleteProvider,
    enableRichInlineNodes: enableRichInlineNodes,
    onSyntaxHelp: onSyntaxHelp
  }, /*#__PURE__*/_react.default.createElement(_useEditorTheme.EditorThemeContext.Provider, {
    value: editorTheme
  }, /*#__PURE__*/_react.default.createElement(_jqlEditorPortalProvider.JQLEditorPortalRenderer, null, /*#__PURE__*/_react.default.createElement(_jqlEditorView.default, {
    inputRef: inputRef
  }))));
};
var _default = (0, _reactIntlNext.injectIntl)(JQLEditorInner);
exports.default = _default;