import { css } from '@emotion/react';
import styled from '@emotion/styled';
import { N100, N20, N50, N800 } from '@atlaskit/theme/colors';
import { codeFontFamily, fontFamily,
// eslint-disable-next-line @atlaskit/design-system/no-deprecated-imports
gridSize } from '@atlaskit/theme/constants';
export const TooltipContent = styled.div`
  font-family: ${fontFamily};
`;

// eslint-disable-next-line @atlaskit/design-system/ensure-design-token-usage
export const OptionListItem = styled.li`
  cursor: pointer;
  padding: ${"var(--ds-space-075, 6px)"} ${5 / 4 * gridSize()}px;
  font-family: ${codeFontFamily};
  line-height: 24px;
  ${props => props.isSelected ? css`
          background: ${`var(--ds-background-neutral-subtle-hovered, ${N20})`};
        ` : ''}
  ${props => props.isDeprecated ? css`
          cursor: default;
          color: ${`var(--ds-text-disabled, ${N50})`};
        ` : ''}
`;
export const OptionName = styled.div`
  color: ${`var(--ds-text, ${N800})`};
  overflow: hidden;
  white-space: nowrap;
  text-overflow: ellipsis;
  // Added so that overflowed option names do not squish the deprecated info icon
  flex: 1;
`;
export const DeprecatedOptionContainer = styled.div`
  color: ${`var(--ds-text-disabled, ${N50})`};
  display: flex;
  justify-content: space-between;
  opacity: 0.6;
`;
export const OptionHighlight = styled.span`
  font-weight: bold;
`;
export const FieldType = styled.div`
  display: flex;
  align-items: center;
  margin-top: calc(-1 * ${"var(--ds-space-025, 2px)"});
  color: ${`var(--ds-text-subtlest, ${N100})`};
`;
export const FieldTypeIcon = styled.span`
  display: flex;
  margin-right: ${"var(--ds-space-050, 4px)"};
`;