import _defineProperty from "@babel/runtime/helpers/defineProperty";
export class PluginKeymap {
  constructor() {
    _defineProperty(this, "keymap", {});
  }
  bindKey(key, handler) {
    this.keymap = {
      ...this.keymap,
      [key]: handler
    };
  }
  bindMultipleKeys(keys, handler) {
    keys.forEach(key => {
      this.keymap = {
        ...this.keymap,
        [key]: handler
      };
    });
  }
  unbindKey(key) {
    const {
      [key]: keyToUnbind,
      ...rest
    } = this.keymap;
    this.keymap = rest;
  }
  getKeyBinding(key) {
    return this.keymap[key];
  }
}