import React from 'react';
import Avatar from '@atlaskit/avatar';
import { useHydratedUser } from '../../../../state';
import { AvatarWrapper, NameContainer, UserContainer } from './styled';
const User = ({
  id,
  name,
  fieldName,
  selected,
  error
}) => {
  const [user] = useHydratedUser({
    id,
    fieldName
  });
  return /*#__PURE__*/React.createElement(UserContainer, {
    selected: selected,
    error: error
  }, /*#__PURE__*/React.createElement(AvatarWrapper, null, /*#__PURE__*/React.createElement(Avatar, {
    src: user === null || user === void 0 ? void 0 : user.avatarUrl,
    borderColor: "transparent",
    size: "xsmall"
  })), /*#__PURE__*/React.createElement(NameContainer, null, name));
};
export const user = {
  component: User,
  attrs: {
    id: {},
    name: {},
    fieldName: {}
  }
};