import React from 'react';
import { IntlProvider } from 'react-intl-next';
export const withIntlProvider = WrappedComponent => {
  return props => {
    const {
      locale,
      ...rest
    } = props;
    if (locale) {
      return /*#__PURE__*/React.createElement(IntlProvider, {
        locale: locale
      }, /*#__PURE__*/React.createElement(WrappedComponent, rest));
    }
    return /*#__PURE__*/React.createElement(WrappedComponent, rest);
  };
};