import React from 'react';
import Button from '@atlaskit/button';
import QuestionIcon from '@atlaskit/icon/glyph/question';
import { N0 } from '@atlaskit/theme/colors';
import { SyntaxHelpContainer } from './styled';
export const BaseSyntaxHelp = ({
  describedby,
  isDisabled,
  label,
  onClick
}) => {
  return /*#__PURE__*/React.createElement(SyntaxHelpContainer, null, /*#__PURE__*/React.createElement(Button, {
    "aria-describedby": describedby,
    "aria-label": label,
    isDisabled: isDisabled,
    appearance: 'subtle',
    spacing: 'none',
    target: 'blank',
    href: "https://confluence.atlassian.com/display/SERVICEDESKCLOUD/Advanced+searching",
    iconBefore: /*#__PURE__*/React.createElement(QuestionIcon, {
      label: '',
      primaryColor: isDisabled ? `var(--ds-icon-disabled, ${N0})` : `var(--ds-icon-inverse, ${N0})`,
      size: 'small'
    }),
    onClick: onClick
  }));
};