import styled from '@emotion/styled';
import { N50, N500, N600, N70 } from '@atlaskit/theme/colors';
export const SyntaxHelpContainer = styled.div`
  /* Override background styles for our button to match designs */

  > a {
    background: ${`var(--ds-background-neutral-bold, ${N70})`};
    border-radius: 100%;
    /* Fill the remaining vertical space for a single line in our editor and space between buttons */
    margin: ${"var(--ds-space-050, 4px)"};

    &:hover {
      background: ${`var(--ds-background-neutral-bold-hovered, ${N500})`};
    }

    &:focus {
      background: ${`var(--ds-background-neutral-bold, ${N70})`};
    }

    &:active,
    &[data-firefox-is-active='true'] {
      background: ${`var(--ds-background-neutral-bold-pressed, ${N600})`};
    }

    &[disabled] {
      background: ${`var(--ds-background-disabled, ${N50})`};
    }
  }
`;