import React from 'react';
import { useEditorThemeContext } from '../../../../hooks/use-editor-theme';
import { MessageContainer as MessageContainerStyled, MessageList } from './styled';

// Max number messages we want to show
const MAX_MESSAGES = 10;
export const MessageContainer = ({
  children
}) => {
  const {
    isSearch
  } = useEditorThemeContext();
  return /*#__PURE__*/React.createElement(MessageContainerStyled, {
    isSearch: isSearch
  }, children);
};
export const FormatMessages = ({
  messages
}) => {
  if (messages.length === 0) {
    return null;
  }
  if (messages.length === 1) {
    return /*#__PURE__*/React.createElement("span", null, messages[0].message);
  }
  return /*#__PURE__*/React.createElement(MessageList, null, messages.slice(0, MAX_MESSAGES).map((m, i) => /*#__PURE__*/React.createElement("li", {
    key: i
  }, m.message)));
};