import React from 'react';
import { di } from 'react-magnetic-di';
import { HelperMessage } from '@atlaskit/form';
import InfoIcon from '@atlaskit/icon/glyph/info';
import * as colors from '@atlaskit/theme/colors';
import { useEditorViewHasInfos } from '../../../../hooks/use-editor-view-has-infos';
import { useExternalMessages } from '../../../../state';
import { FormatMessages, MessageContainer } from '../format';
export const useFormattedInfoMessage = () => {
  const [{
    infos: externalInfos
  }] = useExternalMessages();
  const hasInfos = useEditorViewHasInfos();
  if (!hasInfos) {
    return null;
  }
  return /*#__PURE__*/React.createElement(FormatMessages, {
    messages: externalInfos
  });
};
export const InfoMessages = () => {
  const infoMessage = useFormattedInfoMessage();
  return infoMessage != null ? /*#__PURE__*/React.createElement(MessageContainer, null, /*#__PURE__*/React.createElement(HelperMessage, {
    testId: "jql-editor-info-message"
  }, /*#__PURE__*/React.createElement(InfoIcon, {
    label: "",
    primaryColor: `var(--ds-icon-information, ${colors.B500})`,
    size: "small"
  }), infoMessage)) : null;
};