import _defineProperty from "@babel/runtime/helpers/defineProperty";
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
/**
 * Copied from https://bitbucket.org/atlassian/atlassian-frontend/src/master/packages/analytics/analytics-listeners/src/analytics-web-client-wrapper.ts
 * In future if this package is migrated into the Atlassian Frontend repo, then this code and related logic should be
 * moved into @atlaskit/analytics-listeners.
 */

var isPromise = function isPromise(c) {
  return typeof c.then === 'function';
};
export var sendEvent = function sendEvent(logger, client) {
  return function (event) {
    if (client) {
      var gasEvent = _objectSpread({}, event);
      /*
      Merging this ts-ignore is not going to affect the type definitions of the package
      there's a whole lot more wrong going on here than just this delete.
      All the send methods on the client take a GasPurePayload object which requires actionSubject
      actionSubject is missing on GasPayload | GasScreenEventPayload
      */
      // @ts-ignore mergeable @fixme TypeScript 4.2.4 upgrade
      delete gasEvent.eventType;
      var withClient = function withClient(cb) {
        if (isPromise(client)) {
          client.then(cb).catch(function (e) {
            return logger.warn('There was an error sending the event', e);
          });
        } else {
          try {
            cb(client);
          } catch (e) {
            logger.warn('There was an error sending the event', e);
          }
        }
      };
      switch (event.eventType) {
        case 'ui':
          logger.debug('Sending UI Event via analytics client', gasEvent);
          withClient(function (client) {
            return client.sendUIEvent(gasEvent);
          });
          break;
        case 'operational':
          logger.debug('Sending Operational Event via analytics client', gasEvent);
          withClient(function (client) {
            return client.sendOperationalEvent(gasEvent);
          });
          break;
        case 'track':
          logger.debug('Sending Track Event via analytics client', gasEvent);
          withClient(function (client) {
            return client.sendTrackEvent(gasEvent);
          });
          break;
        case 'screen':
          logger.debug('Sending Screen Event via analytics client', gasEvent);
          withClient(function (client) {
            return client.sendScreenEvent(gasEvent);
          });
          break;
        default:
          logger.error("cannot map eventType ".concat(event.eventType, " to an analytics-web-client function"));
      }
    } else {
      logger.warn('AnalyticsWebClient instance is not provided');
    }
  };
};