import React from 'react';
import { lazyForPaint, LazySuspense } from 'react-loosely-lazy';
import { withErrorBoundary } from './ui/error-boundary';
import { withIntlProvider } from './ui/intl-provider';
import { JQLEditorReadOnly } from './ui/jql-editor-layout';
var JQLEditor = lazyForPaint(function () {
  return import( /* webpackChunkName: "async-jql-editor" */'./ui/jql-editor').then(function (_ref) {
    var JQLEditorUI = _ref.default;
    return JQLEditorUI;
  });
}, {
  ssr: false
});
export var JQLEditorAsync = withIntlProvider(withErrorBoundary(function (props) {
  return /*#__PURE__*/React.createElement(LazySuspense, {
    fallback: /*#__PURE__*/React.createElement(JQLEditorReadOnly, {
      query: props.query,
      isSearch: !!props.onSearch,
      isCompact: props.isCompact
    })
  }, /*#__PURE__*/React.createElement(JQLEditor, props));
}));