import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import { AbstractJastVisitor, isOperandNode } from '@atlassianlabs/jql-ast';
import getDocumentPosition from '../common/get-document-position';
export var SyntaxHighlightingVisitor = /*#__PURE__*/function (_AbstractJastVisitor) {
  _inherits(SyntaxHighlightingVisitor, _AbstractJastVisitor);
  var _super = _createSuper(SyntaxHighlightingVisitor);
  function SyntaxHighlightingVisitor(state) {
    var _this;
    _classCallCheck(this, SyntaxHighlightingVisitor);
    _this = _super.call(this);
    _defineProperty(_assertThisInitialized(_this), "visitCompoundOperator", function (compoundOperator) {
      return compoundOperator.positions.map(function (position) {
        return _this.createHighlight('keyword', position);
      });
    });
    _defineProperty(_assertThisInitialized(_this), "visitNotClauseOperator", function (notClauseOperator) {
      return _this.getHighlightsIfPosition('keyword', notClauseOperator.position);
    });
    _defineProperty(_assertThisInitialized(_this), "visitOrderByOperator", function (orderByOperator) {
      return _this.getHighlightsIfPosition('keyword', orderByOperator.position);
    });
    _defineProperty(_assertThisInitialized(_this), "visitOrderByDirection", function (orderByDirection) {
      return _this.getHighlightsIfPosition('keyword', orderByDirection.position);
    });
    _defineProperty(_assertThisInitialized(_this), "visitField", function (field) {
      return _this.getHighlightsIfPosition('field', field.position);
    });
    _defineProperty(_assertThisInitialized(_this), "visitOperator", function (operator) {
      return _this.getHighlightsIfPosition('operator', operator.position);
    });
    _defineProperty(_assertThisInitialized(_this), "visitPredicateOperator", function (predicateOperator) {
      return _this.getHighlightsIfPosition('operator', predicateOperator.position);
    });
    _defineProperty(_assertThisInitialized(_this), "getHighlightsIfPosition", function (tokenType, maybePosition) {
      if (!maybePosition) {
        return [];
      }
      return [_this.createHighlight(tokenType, maybePosition)];
    });
    _defineProperty(_assertThisInitialized(_this), "createHighlight", function (tokenType, _ref) {
      var _ref2 = _slicedToArray(_ref, 2),
        start = _ref2[0],
        end = _ref2[1];
      var documentFrom = getDocumentPosition(_this.state.doc, start);
      var documentTo = getDocumentPosition(_this.state.doc, end);
      return {
        tokenType: tokenType,
        documentFrom: documentFrom,
        documentTo: documentTo
      };
    });
    _this.state = state;
    return _this;
  }
  _createClass(SyntaxHighlightingVisitor, [{
    key: "shouldVisitNextChild",
    value: function shouldVisitNextChild(node) {
      // Skip visiting operand subtrees, which don't require syntax highlighting and can make a big impact on performance
      return !isOperandNode(node);
    }
  }, {
    key: "aggregateResult",
    value: function aggregateResult(aggregate, nextResult) {
      return aggregate.concat(nextResult);
    }
  }, {
    key: "defaultResult",
    value: function defaultResult() {
      return [];
    }
  }]);
  return SyntaxHighlightingVisitor;
}(AbstractJastVisitor);