import _taggedTemplateLiteral from "@babel/runtime/helpers/taggedTemplateLiteral";
var _templateObject, _templateObject2, _templateObject3, _templateObject4, _templateObject5, _templateObject6, _templateObject7, _templateObject8, _templateObject9, _templateObject10, _templateObject11, _templateObject12, _templateObject13, _templateObject14, _templateObject15;
import { css, keyframes } from '@emotion/react';
import styled from '@emotion/styled';
import { B100, B300, G300, N0, N10, N100, N30, N40, N700, N800, N900, P400, R400 } from '@atlaskit/theme/colors';
import { codeFontFamily, fontFamily, fontSize,
// eslint-disable-next-line @atlaskit/design-system/no-deprecated-imports
gridSize, layers } from '@atlaskit/theme/constants';
import { TOOLTIP_CLASSNAME, TOOLTIP_ENTER_CLASSNAME, TOOLTIP_EXIT_CLASSNAME } from '../../plugins/validation-tooltip/constants';
var fadeIn = keyframes(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  from {\n    opacity: 0;\n  }\n\n  to {\n    opacity: 1;\n  }\n"])));
var fadeOut = keyframes(_templateObject2 || (_templateObject2 = _taggedTemplateLiteral(["\n  from {\n    visibility: visible;\n    opacity: 1;\n  }\n\n  to {\n    opacity: 0;\n  }\n"])));
export var EditorMain = styled.div(_templateObject3 || (_templateObject3 = _taggedTemplateLiteral(["\n  /* CSS reset */\n  font-family: ", ";\n  font-size: ", "px;\n  flex-grow: 1;\n\n  /* These styles and animations are derived from @atlaskit/tooltip */\n\n  .", " {\n    background-color: ", ";\n    color: ", ";\n    border-radius: ", ";\n    box-sizing: border-box;\n    font-size: 12px;\n    line-height: 1.3;\n    max-width: 240px;\n    padding: ", " ", ";\n    word-wrap: break-word;\n    overflow-wrap: break-word;\n    z-index: ", ";\n    pointer-events: none;\n    position: absolute;\n    visibility: hidden;\n\n    /* Horizontally center and vertically position above the target element */\n    transform: translate(-50%, calc(-100% - ", "));\n\n    &.", " {\n      animation: ", " 350ms cubic-bezier(0.15, 1, 0.3, 1);\n      visibility: visible;\n    }\n\n    &.", " {\n      animation: ", " 350ms cubic-bezier(0.15, 1, 0.3, 1);\n    }\n  }\n"])), fontFamily, fontSize, TOOLTIP_CLASSNAME, "var(--ds-background-neutral-bold, ".concat(N800, ")"), "var(--ds-text-inverse, ".concat(N0, ")"), "var(--ds-border-radius-100, 3px)", "var(--ds-space-025, 2px)", "var(--ds-space-075, 6px)", layers.tooltip(), "var(--ds-space-200, 16px)", TOOLTIP_ENTER_CLASSNAME, fadeIn, TOOLTIP_EXIT_CLASSNAME, fadeOut);
export var EditorFooter = styled.div(_templateObject4 || (_templateObject4 = _taggedTemplateLiteral(["\n  display: flex;\n  justify-content: space-between;\n  /* We always have at least 1 row of space allocated to the footer */\n  min-height: 20px;\n"])));

// Height (in px) for a single row in the editor
var rowHeight = gridSize() * 2.75;
// Vertical padding for the editor input
var getEditorInputVerticalPadding = function getEditorInputVerticalPadding(isCompact) {
  return isCompact ? 3 : 7;
};
var editorInputHorizontalPadding = 6;
export var EditorViewContainer = styled.div(_templateObject5 || (_templateObject5 = _taggedTemplateLiteral(["\n  background-color: ", ";\n  border-style: solid;\n  border-width: 2px;\n  border-color: ", ";\n  border-radius: ", ";\n  box-sizing: border-box;\n  color: ", ";\n  display: flex;\n  overflow: auto;\n  transition: background-color 0.2s ease-in-out, border-color 0.2s ease-in-out;\n\n  ", "\n\n  ", "\n"])), "var(--ds-background-input, ".concat(N10, ")"), "var(--ds-border, ".concat(N40, ")"), "var(--ds-border-radius-100, 3px)", "var(--ds-text, ".concat(N900, ")"), function (props) {
  return props.editorViewHasFocus ? css(_templateObject6 || (_templateObject6 = _taggedTemplateLiteral(["\n          background-color: ", ";\n          border-color: ", ";\n        "])), "var(--ds-surface, ".concat(N0, ")"), "var(--ds-border-focused, ".concat(B100, ")")) : css(_templateObject7 || (_templateObject7 = _taggedTemplateLiteral(["\n          :hover {\n            background-color: ", ";\n          }\n        "])), "var(--ds-background-input-hovered, ".concat(N30, ")"));
}, function (props) {
  return props.editorViewIsInvalid && css(_templateObject8 || (_templateObject8 = _taggedTemplateLiteral(["\n      border-color: ", ";\n    "])), "var(--ds-border-danger, ".concat(R400, ")"));
});
export var ReadOnlyEditorViewContainer = styled(EditorViewContainer)(_templateObject9 || (_templateObject9 = _taggedTemplateLiteral(["\n  background-color: ", ";\n  color: ", ";\n  pointer-events: none;\n"])), "var(--ds-background-disabled, ".concat(N30, ")"), "var(--ds-text-disabled, ".concat(N100, ")"));
export var LineNumberToolbar = styled.div(_templateObject10 || (_templateObject10 = _taggedTemplateLiteral(["\n  background-color: ", ";\n  flex-shrink: 0;\n  width: 30px;\n  position: sticky;\n  top: 0;\n\n  ", "\n"])), "var(--ds-background-neutral, ".concat(N30, ")"), function (props) {
  return !props.lineNumbersVisible && css(_templateObject11 || (_templateObject11 = _taggedTemplateLiteral(["\n      display: none;\n    "])));
});

/**
 * The main div which the Prosemirror editor will be rendered into.
 */
export var EditorView = styled.div(_templateObject12 || (_templateObject12 = _taggedTemplateLiteral(["\n  counter-reset: lineNumber;\n  flex-grow: 1;\n\n  transition: height 250ms cubic-bezier(0.15, 1, 0.3, 1),\n    max-height 250ms cubic-bezier(0.15, 1, 0.3, 1);\n  max-height: ", "px;\n\n  line-height: ", ";\n  font-family: ", ";\n  word-break: break-word;\n  overflow-wrap: anywhere;\n  white-space: pre-wrap;\n\n  &[data-expanded] {\n    height: ", "px;\n    max-height: ", "px;\n  }\n\n  .ProseMirror {\n    color: ", ";\n    padding: ", "px\n      ", "px;\n\n    &:focus {\n      outline: none;\n    }\n\n    .mark-token-keyword {\n      color: ", ";\n    }\n\n    .mark-token-field {\n      color: ", ";\n    }\n\n    .mark-token-operator {\n      color: ", ";\n    }\n\n    .mark-token-error {\n      color: ", ";\n      text-decoration: wavy underline;\n      text-decoration-thickness: 1px;\n      text-decoration-skip-ink: none;\n    }\n  }\n\n  p {\n    margin: 0;\n    counter-increment: lineNumber;\n    position: relative;\n\n    /* Show the current line number before each paragraph block. */\n\n    &::before {\n      content: counter(lineNumber);\n      color: ", ";\n      font-size: 10px;\n      line-height: ", ";\n      padding: 0 ", " 0 ", ";\n      position: absolute;\n      box-sizing: border-box;\n      /* Shift the line number tag 100% (plus 8px padding) to the left to position it inside the LineNumberToolbar */\n      transform: translateX(calc(-100% - ", "));\n\n      /* We can fit 3 digits before ellipses. This is not very responsive but saves us having to add expensive width\n        recalculation logic to the LineNumberToolbar for a scenario that *should* never happen. */\n      max-width: 30px;\n      text-overflow: ellipsis;\n      overflow: hidden;\n      white-space: nowrap;\n\n      ", "\n    }\n  }\n"])), function (props) {
  return rowHeight * props.defaultMaxRows + getEditorInputVerticalPadding(props.isCompact) * 2;
}, rowHeight / fontSize(), codeFontFamily, function (props) {
  return rowHeight * props.expandedRows + getEditorInputVerticalPadding(props.isCompact) * 2;
}, function (props) {
  return rowHeight * props.expandedRows + getEditorInputVerticalPadding(props.isCompact) * 2;
}, "var(--ds-text, ".concat(N700, ")"), function (props) {
  return getEditorInputVerticalPadding(props.isCompact);
}, editorInputHorizontalPadding, "var(--ds-text-accent-purple, ".concat(P400, ")"), "var(--ds-text-accent-blue, ".concat(B300, ")"), "var(--ds-text-accent-green, ".concat(G300, ")"), "var(--ds-text-danger, ".concat(R400, ")"), "var(--ds-text-subtlest, ".concat(N100, ")"), rowHeight / 10, "var(--ds-space-100, 8px)", "var(--ds-space-025, 2px)", "var(--ds-space-100, 8px)", function (props) {
  return !props.lineNumbersVisible && css(_templateObject13 || (_templateObject13 = _taggedTemplateLiteral(["\n          display: none;\n        "])));
});
export var ReadOnlyEditorView = styled(EditorView)(_templateObject14 || (_templateObject14 = _taggedTemplateLiteral(["\n  /* We need to replicate padding from the inner prosemirror element in our read only state. That means we also need\n  recompute max height excluding the child padding. */\n  padding: ", "px\n    ", "px;\n  max-height: ", "px;\n\n  > p {\n    /* Prevent collapsing empty paragraphs */\n    min-height: ", "px;\n  }\n"])), function (props) {
  return getEditorInputVerticalPadding(props.isCompact);
}, editorInputHorizontalPadding, function (props) {
  return rowHeight * props.defaultMaxRows;
}, rowHeight);
export var EditorControls = styled.div(_templateObject15 || (_templateObject15 = _taggedTemplateLiteral(["\n  align-items: center;\n  display: flex;\n  flex-shrink: 0;\n  margin-left: auto;\n  margin-right: ", "px;\n  line-height: normal;\n  position: sticky;\n  top: 0;\n  height: ", "px;\n"])), function (props) {
  return props.isSearch ? getEditorInputVerticalPadding(props.isCompact) - 1 // the search button needs the same vertical & horizontal spacing
  : editorInputHorizontalPadding - 3;
}, function (props) {
  return rowHeight + 2 * getEditorInputVerticalPadding(props.isCompact);
});