import { FunctionComponent } from 'react';
import { Slice } from 'prosemirror-model';
import { EditorState } from 'prosemirror-state';
import { EditorView } from 'prosemirror-view';
import { PortalActions } from '../../ui/jql-editor-portal-provider/types';
import { PluginKeymap } from '../common/plugin-keymap';
import ReactPluginView from '../common/react-plugin-view';
import { AutocompleteProps, SelectableAutocompleteOption } from './components/types';
export default class AutocompletePluginView extends ReactPluginView<AutocompleteProps> {
    private readonly view;
    private readonly keymap;
    private readonly enableRichInlineNodes;
    constructor(view: EditorView, keymap: PluginKeymap, portalActions: PortalActions, enableRichInlineNodes: boolean);
    getComponent: () => FunctionComponent<AutocompleteProps>;
    getInitialComponentProps: () => AutocompleteProps;
    isSameState(state: EditorState, prevState: EditorState): boolean;
    onReplaceSuggestion: (option: SelectableAutocompleteOption) => void;
    getSliceForSuggestion: (option: SelectableAutocompleteOption) => Slice;
}
