import { MutableRefObject } from 'react';
import { JQLParser } from '@atlassianlabs/jql-parser';
import { DefaultErrorStrategy, FailedPredicateException, InputMismatchException, Parser } from 'antlr4ts';
import { NoViableAltException } from 'antlr4ts/NoViableAltException';
import { IntlShape } from 'react-intl-next';
export declare const getPrintableChar: (char: string) => string;
export declare const getJavaCodeFromChar: (char: string) => string;
export default class JQLEditorErrorStrategy extends DefaultErrorStrategy {
    intlRef: MutableRefObject<IntlShape>;
    constructor(intlRef: MutableRefObject<IntlShape>);
    protected reportInputMismatch(recognizer: JQLParser, exception: InputMismatchException): void;
    protected reportUnwantedToken(recognizer: JQLParser): void;
    protected reportMissingToken(recognizer: JQLParser): void;
    protected reportNoViableAlternative(recognizer: JQLParser, exception: NoViableAltException): void;
    protected reportFailedPredicate(recognizer: Parser, e: FailedPredicateException): void;
    private handleSyntaxError;
}
