import { AbstractJastVisitor, AstNode, CompoundOperator, Field, NotClauseOperator, Operator, OrderByDirection, OrderByOperator, PredicateOperator } from '@atlassianlabs/jql-ast';
import { EditorState } from 'prosemirror-state';
import { Highlight } from './types';
export declare class SyntaxHighlightingVisitor extends AbstractJastVisitor<Highlight[]> {
    state: EditorState;
    constructor(state: EditorState);
    visitCompoundOperator: (compoundOperator: CompoundOperator) => Highlight[];
    visitNotClauseOperator: (notClauseOperator: NotClauseOperator) => Highlight[];
    visitOrderByOperator: (orderByOperator: OrderByOperator) => Highlight[];
    visitOrderByDirection: (orderByDirection: OrderByDirection) => Highlight[];
    visitField: (field: Field) => Highlight[];
    visitOperator: (operator: Operator) => Highlight[];
    visitPredicateOperator: (predicateOperator: PredicateOperator) => Highlight[];
    protected shouldVisitNextChild(node: AstNode): boolean;
    protected aggregateResult(aggregate: Highlight[], nextResult: Highlight[]): Highlight[];
    protected defaultResult(): never[];
    private getHighlightsIfPosition;
    private createHighlight;
}
