import { Jast } from '@atlassianlabs/jql-ast';
import { JQLSuggestions } from '@atlassianlabs/jql-autocomplete';
import { EditorState } from 'prosemirror-state';
import { EditorView } from 'prosemirror-view';
import { SelectableAutocompleteOptions } from '../plugins/autocomplete/components/types';
import { AutocompletePosition, ContextAwareTokenSuggestions, DebugMessageEventAttribute } from './types';
export declare const getAutocompleteOptionId: (value: string) => string;
export declare const tokensToAutocompleteOptions: (tokens: ContextAwareTokenSuggestions) => SelectableAutocompleteOptions;
export declare const getReplacePositionStart: ({ rules, tokens, }: JQLSuggestions) => number;
export declare const getAutocompletePosition: (editorView: EditorView, replacePositionStart: number) => AutocompletePosition;
export declare const sendDebugMessage: (message: string, editorView: EditorView, editorState: EditorState, onDebugUnsafeMessage?: ((message: string, event: {
    [key: string]: DebugMessageEventAttribute;
}) => void) | undefined, eventAttributes?: {
    [key: string]: DebugMessageEventAttribute;
} | undefined) => void;
export declare const getFieldNodes: (ast: Jast) => Set<string>;
