import { JQLRuleContext, Position } from '@atlassianlabs/jql-autocomplete';
import { AutocompleteOption } from '@atlassianlabs/jql-editor-common';
import { PluginKeymap } from '../../common/plugin-keymap';
export type { AutocompleteProvider, AutocompleteOptions, AutocompleteOption, AutocompleteValueType, } from '@atlassianlabs/jql-editor-common';
export type AutocompleteOptionType = 'field' | 'operator' | 'value' | 'function' | 'keyword';
export type AutocompleteOptionExtra = {
    replacePosition: Position;
    context: JQLRuleContext | null;
    matchedText: string;
    type: AutocompleteOptionType;
};
export type SelectableAutocompleteOption = AutocompleteOption & AutocompleteOptionExtra & {
    id: string;
};
export type SelectableAutocompleteOptions = SelectableAutocompleteOption[];
export type AutocompleteOptionGroup = {
    tokens: SelectableAutocompleteOptions;
    fields: SelectableAutocompleteOptions;
    operators: SelectableAutocompleteOptions;
    values: SelectableAutocompleteOptions;
    functions: SelectableAutocompleteOptions;
};
export type AutocompletePosition = {
    top: number;
    left: number;
};
export type AutocompleteProps = {
    keymap: PluginKeymap;
    onClick: (option: SelectableAutocompleteOption) => void;
};
export type AutocompleteAnalyticsAttributes = {
    keyboard: boolean;
    numberOfOptions: number;
    optionIndex: number;
    optionType: AutocompleteOptionType;
    queryLength: number;
    nodeType: string;
};
