"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.processEventPayload = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _merge2 = _interopRequireDefault(require("lodash/merge"));
var _analyticsGasTypes = require("@atlaskit/analytics-gas-types");
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { (0, _defineProperty2.default)(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * Adapted from https://bitbucket.org/atlassian/atlassian-frontend/src/master/packages/analytics/analytics-listeners/src/fabric/process-event-payload.tsx
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * In future if this package is migrated into the Atlassian Frontend repo, then this code and related logic should be
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          * moved into @atlaskit/analytics-listeners.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          */
var extractFieldsFromContext = function extractFieldsFromContext(fieldsToPick) {
  return function (contexts) {
    return contexts.map(function (ctx) {
      return fieldsToPick.reduce(function (result, key) {
        return ctx[key] ? (0, _merge2.default)(result, (0, _defineProperty2.default)({}, key, ctx[key])) : result;
      }, {});
    }).reduce(function (result, item) {
      return (0, _merge2.default)(result, item);
    }, {});
  };
};
var fieldExtractor = function fieldExtractor() {
  return extractFieldsFromContext(['source', 'objectType', 'objectId', 'containerType', 'containerId']);
};
var updatePayloadWithContext = function updatePayloadWithContext(event) {
  if (event.context.length === 0) {
    return _objectSpread({
      source: _analyticsGasTypes.DEFAULT_SOURCE
    }, event.payload);
  }
  var fields = fieldExtractor()(event.context);
  return _objectSpread(_objectSpread({
    source: _analyticsGasTypes.DEFAULT_SOURCE
  }, fields), event.payload);
};
var processEventPayload = function processEventPayload(event) {
  return updatePayloadWithContext(event);
};
exports.processEventPayload = processEventPayload;